diff --git a/examples/l2fwd-event/l2fwd_event.c b/examples/l2fwd-event/l2fwd_event.c
index 9b315e5e1..293ecc129 100644
--- a/examples/l2fwd-event/l2fwd_event.c
+++ b/examples/l2fwd-event/l2fwd_event.c
@@ -68,4 +68,7 @@ l2fwd_event_resource_setup(struct l2fwd_resources *l2fwd_rsrc)
 
 	/* Event port configuration */
 	event_rsrc->ops.event_port_setup(l2fwd_rsrc);
+
+	/* Rx/Tx adapters configuration */
+	event_rsrc->ops.adapter_setup(l2fwd_rsrc);
 }
diff --git a/examples/l2fwd-event/l2fwd_event.h b/examples/l2fwd-event/l2fwd_event.h
index 93d254cf3..e0cfee8b8 100644
--- a/examples/l2fwd-event/l2fwd_event.h
+++ b/examples/l2fwd-event/l2fwd_event.h
@@ -17,6 +17,7 @@ typedef uint32_t (*event_device_setup_cb)(struct l2fwd_resources *l2fwd_rsrc);
 typedef void (*event_port_setup_cb)(struct l2fwd_resources *l2fwd_rsrc);
 typedef void (*event_queue_setup_cb)(struct l2fwd_resources *l2fwd_rsrc,
 				     uint32_t event_queue_cfg);
+typedef void (*adapter_setup_cb)(struct l2fwd_resources *l2fwd_rsrc);
 
 struct event_queues {
 	uint8_t *event_q_id;
@@ -29,10 +30,23 @@ struct event_ports {
 	rte_spinlock_t lock;
 };
 
+struct event_rx_adptr {
+	uint32_t service_id;
+	uint8_t	nb_rx_adptr;
+	uint8_t *rx_adptr;
+};
+
+struct event_tx_adptr {
+	uint32_t service_id;
+	uint8_t	nb_tx_adptr;
+	uint8_t *tx_adptr;
+};
+
 struct event_setup_ops {
 	event_device_setup_cb event_device_setup;
 	event_queue_setup_cb event_queue_setup;
 	event_port_setup_cb event_port_setup;
+	adapter_setup_cb adapter_setup;
 };
 
 struct l2fwd_event_resources {
@@ -44,6 +58,8 @@ struct l2fwd_event_resources {
 	struct event_ports evp;
 	struct event_queues evq;
 	struct event_setup_ops ops;
+	struct event_rx_adptr rx_adptr;
+	struct event_tx_adptr tx_adptr;
 	struct rte_event_port_conf def_p_conf;
 };
 
diff --git a/examples/l2fwd-event/l2fwd_event_generic.c b/examples/l2fwd-event/l2fwd_event_generic.c
index 6922e2e5e..bce00f631 100644
--- a/examples/l2fwd-event/l2fwd_event_generic.c
+++ b/examples/l2fwd-event/l2fwd_event_generic.c
@@ -198,10 +198,135 @@ l2fwd_event_queue_setup_generic(struct l2fwd_resources *l2fwd_rsrc,
 	event_rsrc->evq.event_q_id[event_q_id] = event_q_id;
 }
 
+static void
+l2fwd_rx_tx_adapter_setup_generic(struct l2fwd_resources *l2fwd_rsrc)
+{
+	struct l2fwd_event_resources *event_rsrc = l2fwd_rsrc->event_rsrc;
+	struct rte_event_eth_rx_adapter_queue_conf eth_q_conf = {
+		.rx_queue_flags = 0,
+		.ev = {
+			.queue_id = 0,
+			.priority = RTE_EVENT_DEV_PRIORITY_NORMAL,
+		}
+	};
+	uint8_t event_d_id = event_rsrc->event_d_id;
+	uint8_t rx_adptr_id = 0;
+	uint8_t tx_adptr_id = 0;
+	uint8_t tx_port_id = 0;
+	uint16_t port_id;
+	uint32_t service_id;
+	int32_t ret, i = 0;
+
+	/* Rx adapter setup */
+	event_rsrc->rx_adptr.nb_rx_adptr = 1;
+	event_rsrc->rx_adptr.rx_adptr = (uint8_t *)malloc(sizeof(uint8_t) *
+					event_rsrc->rx_adptr.nb_rx_adptr);
+	if (!event_rsrc->rx_adptr.rx_adptr) {
+		free(event_rsrc->evp.event_p_id);
+		free(event_rsrc->evq.event_q_id);
+		rte_exit(EXIT_FAILURE,
+			 "failed to allocate memery for Rx adapter");
+	}
+
+	ret = rte_event_eth_rx_adapter_create(rx_adptr_id, event_d_id,
+					      &event_rsrc->def_p_conf);
+	if (ret)
+		rte_exit(EXIT_FAILURE, "failed to create rx adapter");
+
+	/* Configure user requested sched type */
+	eth_q_conf.ev.sched_type = l2fwd_rsrc->sched_type;
+	RTE_ETH_FOREACH_DEV(port_id) {
+		if ((l2fwd_rsrc->enabled_port_mask & (1 << port_id)) == 0)
+			continue;
+		eth_q_conf.ev.queue_id = event_rsrc->evq.event_q_id[i];
+		ret = rte_event_eth_rx_adapter_queue_add(rx_adptr_id, port_id,
+							 -1, &eth_q_conf);
+		if (ret)
+			rte_exit(EXIT_FAILURE,
+				 "Failed to add queues to Rx adapter");
+		if (i < event_rsrc->evq.nb_queues)
+			i++;
+	}
+
+	ret = rte_event_eth_rx_adapter_service_id_get(rx_adptr_id, &service_id);
+	if (ret != -ESRCH && ret != 0) {
+		rte_exit(EXIT_FAILURE,
+			"Error getting the service ID for rx adptr\n");
+	}
+
+	rte_service_runstate_set(service_id, 1);
+	rte_service_set_runstate_mapped_check(service_id, 0);
+	event_rsrc->rx_adptr.service_id = service_id;
+
+	ret = rte_event_eth_rx_adapter_start(rx_adptr_id);
+	if (ret)
+		rte_exit(EXIT_FAILURE, "Rx adapter[%d] start failed",
+			 rx_adptr_id);
+
+	event_rsrc->rx_adptr.rx_adptr[0] = rx_adptr_id;
+
+	/* Tx adapter setup */
+	event_rsrc->tx_adptr.nb_tx_adptr = 1;
+	event_rsrc->tx_adptr.tx_adptr = (uint8_t *)malloc(sizeof(uint8_t) *
+					event_rsrc->tx_adptr.nb_tx_adptr);
+	if (!event_rsrc->tx_adptr.tx_adptr) {
+		free(event_rsrc->rx_adptr.rx_adptr);
+		free(event_rsrc->evp.event_p_id);
+		free(event_rsrc->evq.event_q_id);
+		rte_exit(EXIT_FAILURE,
+			 "failed to allocate memery for Rx adapter");
+	}
+
+	ret = rte_event_eth_tx_adapter_create(tx_adptr_id, event_d_id,
+					      &event_rsrc->def_p_conf);
+	if (ret)
+		rte_exit(EXIT_FAILURE, "failed to create tx adapter");
+
+	RTE_ETH_FOREACH_DEV(port_id) {
+		if ((l2fwd_rsrc->enabled_port_mask & (1 << port_id)) == 0)
+			continue;
+		ret = rte_event_eth_tx_adapter_queue_add(tx_adptr_id, port_id,
+							 -1);
+		if (ret)
+			rte_exit(EXIT_FAILURE,
+				 "failed to add queues to Tx adapter");
+	}
+
+	ret = rte_event_eth_tx_adapter_service_id_get(tx_adptr_id, &service_id);
+	if (ret != -ESRCH && ret != 0)
+		rte_exit(EXIT_FAILURE, "Failed to get Tx adapter service ID");
+
+	rte_service_runstate_set(service_id, 1);
+	rte_service_set_runstate_mapped_check(service_id, 0);
+	event_rsrc->tx_adptr.service_id = service_id;
+
+	ret = rte_event_eth_tx_adapter_event_port_get(tx_adptr_id, &tx_port_id);
+	if (ret)
+		rte_exit(EXIT_FAILURE,
+			 "Failed to get Tx adapter port id: %d\n", ret);
+
+	ret = rte_event_port_link(event_d_id, tx_port_id,
+				  &event_rsrc->evq.event_q_id[
+					event_rsrc->evq.nb_queues - 1],
+				  NULL, 1);
+	if (ret != 1)
+		rte_exit(EXIT_FAILURE,
+			 "Unable to link Tx adapter port to Tx queue:err = %d",
+			 ret);
+
+	ret = rte_event_eth_tx_adapter_start(tx_adptr_id);
+	if (ret)
+		rte_exit(EXIT_FAILURE, "Tx adapter[%d] start failed",
+			 tx_adptr_id);
+
+	event_rsrc->tx_adptr.tx_adptr[0] = tx_adptr_id;
+}
+
 void
 l2fwd_event_set_generic_ops(struct event_setup_ops *ops)
 {
 	ops->event_device_setup = l2fwd_event_device_setup_generic;
 	ops->event_queue_setup = l2fwd_event_queue_setup_generic;
 	ops->event_port_setup = l2fwd_event_port_setup_generic;
+	ops->adapter_setup = l2fwd_rx_tx_adapter_setup_generic;
 }
diff --git a/examples/l2fwd-event/l2fwd_event_internal_port.c b/examples/l2fwd-event/l2fwd_event_internal_port.c
index 6e3c1da5b..71652986d 100644
--- a/examples/l2fwd-event/l2fwd_event_internal_port.c
+++ b/examples/l2fwd-event/l2fwd_event_internal_port.c
@@ -195,10 +195,112 @@ l2fwd_event_queue_setup_internal_port(struct l2fwd_resources *l2fwd_rsrc,
 	}
 }
 
+static void
+l2fwd_rx_tx_adapter_setup_internal_port(struct l2fwd_resources *l2fwd_rsrc)
+{
+	struct l2fwd_event_resources *event_rsrc = l2fwd_rsrc->event_rsrc;
+	struct rte_event_eth_rx_adapter_queue_conf eth_q_conf = {
+		.rx_queue_flags = 0,
+		.ev = {
+			.queue_id = 0,
+			.priority = RTE_EVENT_DEV_PRIORITY_NORMAL,
+		}
+	};
+	uint8_t event_d_id = event_rsrc->event_d_id;
+	uint16_t adapter_id = 0;
+	uint16_t nb_adapter = 0;
+	uint16_t port_id;
+	uint8_t q_id = 0;
+	int ret;
+
+	RTE_ETH_FOREACH_DEV(port_id) {
+		if ((l2fwd_rsrc->enabled_port_mask & (1 << port_id)) == 0)
+			continue;
+		nb_adapter++;
+	}
+
+	event_rsrc->rx_adptr.nb_rx_adptr = nb_adapter;
+	event_rsrc->rx_adptr.rx_adptr = (uint8_t *)malloc(sizeof(uint8_t) *
+					event_rsrc->rx_adptr.nb_rx_adptr);
+	if (!event_rsrc->rx_adptr.rx_adptr) {
+		free(event_rsrc->evp.event_p_id);
+		free(event_rsrc->evq.event_q_id);
+		rte_exit(EXIT_FAILURE,
+			 "failed to allocate memery for Rx adapter");
+	}
+
+
+	RTE_ETH_FOREACH_DEV(port_id) {
+		if ((l2fwd_rsrc->enabled_port_mask & (1 << port_id)) == 0)
+			continue;
+		ret = rte_event_eth_rx_adapter_create(adapter_id, event_d_id,
+						&event_rsrc->def_p_conf);
+		if (ret)
+			rte_exit(EXIT_FAILURE,
+				 "failed to create rx adapter[%d]", adapter_id);
+
+		/* Configure user requested sched type*/
+		eth_q_conf.ev.sched_type = l2fwd_rsrc->sched_type;
+		eth_q_conf.ev.queue_id = event_rsrc->evq.event_q_id[q_id];
+		ret = rte_event_eth_rx_adapter_queue_add(adapter_id, port_id,
+							 -1, &eth_q_conf);
+		if (ret)
+			rte_exit(EXIT_FAILURE,
+				 "Failed to add queues to Rx adapter");
+
+		ret = rte_event_eth_rx_adapter_start(adapter_id);
+		if (ret)
+			rte_exit(EXIT_FAILURE,
+				 "Rx adapter[%d] start failed", adapter_id);
+
+		event_rsrc->rx_adptr.rx_adptr[adapter_id] = adapter_id;
+		adapter_id++;
+		if (q_id < event_rsrc->evq.nb_queues)
+			q_id++;
+	}
+
+	event_rsrc->tx_adptr.nb_tx_adptr = nb_adapter;
+	event_rsrc->tx_adptr.tx_adptr = (uint8_t *)malloc(sizeof(uint8_t) *
+					event_rsrc->tx_adptr.nb_tx_adptr);
+	if (!event_rsrc->tx_adptr.tx_adptr) {
+		free(event_rsrc->rx_adptr.rx_adptr);
+		free(event_rsrc->evp.event_p_id);
+		free(event_rsrc->evq.event_q_id);
+		rte_exit(EXIT_FAILURE,
+			 "failed to allocate memery for Rx adapter");
+	}
+
+	adapter_id = 0;
+	RTE_ETH_FOREACH_DEV(port_id) {
+		if ((l2fwd_rsrc->enabled_port_mask & (1 << port_id)) == 0)
+			continue;
+		ret = rte_event_eth_tx_adapter_create(adapter_id, event_d_id,
+						&event_rsrc->def_p_conf);
+		if (ret)
+			rte_exit(EXIT_FAILURE,
+				 "failed to create tx adapter[%d]", adapter_id);
+
+		ret = rte_event_eth_tx_adapter_queue_add(adapter_id, port_id,
+							 -1);
+		if (ret)
+			rte_exit(EXIT_FAILURE,
+				 "failed to add queues to Tx adapter");
+
+		ret = rte_event_eth_tx_adapter_start(adapter_id);
+		if (ret)
+			rte_exit(EXIT_FAILURE,
+				 "Tx adapter[%d] start failed", adapter_id);
+
+		event_rsrc->tx_adptr.tx_adptr[adapter_id] = adapter_id;
+		adapter_id++;
+	}
+}
+
 void
 l2fwd_event_set_internal_port_ops(struct event_setup_ops *ops)
 {
 	ops->event_device_setup = l2fwd_event_device_setup_internal_port;
 	ops->event_queue_setup = l2fwd_event_queue_setup_internal_port;
 	ops->event_port_setup = l2fwd_event_port_setup_internal_port;
+	ops->adapter_setup = l2fwd_rx_tx_adapter_setup_internal_port;
 }